#include <stdio.h>
#include <stdlib.h>
#include <iostream>     
#include <string.h>
#include <vector>
#include <math.h>
#include <cmath>


#include <opencv2/opencv.hpp>
#include <opencv2/highgui.hpp>
#include <opencv2/imgproc.hpp>

#include <boost/filesystem.hpp>

using namespace cv;
using namespace std;



int
main(int argc, char** argv)
{

    std::string rgbdir = "/usr/wiss/lingni/PhD/teaching/ProbabilisticGraphicalModel-ss16/exercise_sheets/ex12/supp/cows-training/";
    std::string unarydir = "/usr/wiss/lingni/PhD/teaching/ProbabilisticGraphicalModel-ss16/exercise_sheets/ex12/supp/cows-unary/";
    const boost::filesystem::path tbase_dir (rgbdir.c_str());
    int count(0);
    for (boost::filesystem::directory_iterator it (tbase_dir); it != boost::filesystem::directory_iterator (); ++it)
    {
        if (boost::filesystem::is_regular_file (it->status ()) && boost::filesystem::extension(it->path()) ==".bmp")
        {
            std::string basename = boost::filesystem::basename(it->path());
            std::cout << basename << "\n";

            std::string rgbfile = rgbdir + basename + ".bmp";
            std::string unaryfile = unarydir + basename + ".yml";

            cv::Mat rgb = cv::imread(rgbfile, CV_LOAD_IMAGE_COLOR);
            cv::Mat1f unary;
            cv::FileStorage store (unaryfile, cv::FileStorage::READ);
            store["unary"] >> unary;
            store.release ();

            cv::imshow("rgb", rgb);
            cv::imshow("unary", unary);
            cv::waitKey(500);
            count++;
        }

    }
    printf("found %d training images\n", count);
    return 0;
}
